---
title: label
slug: Web/JavaScript/Reference/Statements/label
tags:
  - JavaScript
  - Language feature
  - Statement
---
<div>{{jsSidebar("Statements")}}</div>

<p>The <strong>labeled statement</strong> can be used with {{jsxref("Statements/break", "break")}} or {{jsxref("Statements/continue", "continue")}} statements. It is prefixing a statement with an identifier which you can refer to.</p>

<div>{{EmbedInteractiveExample("pages/js/statement-label.html")}}</div>

<div class="hidden">The source for this interactive example is stored in a GitHub repository. If you'd like to contribute to the interactive examples project, please clone <a href="https://github.com/mdn/interactive-examples">https://github.com/mdn/interactive-examples</a> and send us a pull request.</div>

<div class="note">
<p><strong>Note:</strong> Labeled loops or blocks are very uncommon. Usually function calls can be used instead of loop jumps.</p>
</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate"><em>label</em> :
  <em>statement</em>
</pre>

<dl>
 <dt><code><em>label</em></code></dt>
 <dd>Any JavaScript identifier that is not a reserved word.</dd>
 <dt><code><em>statement</em></code></dt>
 <dd>A JavaScript statement. <code>break</code> can be used with any labeled statement, and <code>continue</code> can be used with looping labeled statements.</dd>
</dl>

<h2 id="Description">Description</h2>

<p>You can use a label to identify a loop, and then use the <code>break</code> or <code>continue</code> statements to indicate whether a program should interrupt the loop or continue its execution.</p>

<p>Note that JavaScript has <em>no</em> <code>goto</code> statement, you can only use labels with <code>break</code> or <code>continue</code>.</p>

<p>In <a href="/en-US/docs/Web/JavaScript/Reference/Strict_mode">strict mode</a> code, you can't use "<code>let</code>" as a label name. It will throw a {{jsxref("SyntaxError")}} (let is a reserved identifier).</p>

<h2 id="Examples">Examples</h2>

<h3 id="Using_a_labeled_continue_with_for_loops">Using a labeled continue with for loops</h3>

<pre class="brush: js notranslate">var i, j;

loop1:
for (i = 0; i &lt; 3; i++) {      //The first for statement is labeled "loop1"
   loop2:
   for (j = 0; j &lt; 3; j++) {   //The second for statement is labeled "loop2"
      if (i === 1 &amp;&amp; j === 1) {
         continue loop1;
      }
      console.log('i = ' + i + ', j = ' + j);
   }
}

// Output is:
//   "i = 0, j = 0"
//   "i = 0, j = 1"
//   "i = 0, j = 2"
//   "i = 1, j = 0"
//   "i = 2, j = 0"
//   "i = 2, j = 1"
//   "i = 2, j = 2"
// Notice how it skips both "i = 1, j = 1" and "i = 1, j = 2"
</pre>

<h3 id="Using_a_labeled_continue_statement">Using a labeled continue statement</h3>

<p>Given an array of items and an array of tests, this example counts the number of items that passes all the tests.</p>

<pre class="brush: js notranslate">var itemsPassed = 0;
var i, j;

top:
for (i = 0; i &lt; items.length; i++) {
  for (j = 0; j &lt; tests.length; j++) {
    if (!tests[j].pass(items[i])) {
      continue top;
    }
  }

  itemsPassed++;
}</pre>

<h3 id="Using_a_labeled_break_with_for_loops">Using a labeled break with for loops</h3>

<pre class="brush: js notranslate">var i, j;

loop1:
for (i = 0; i &lt; 3; i++) {      //The first for statement is labeled "loop1"
   loop2:
   for (j = 0; j &lt; 3; j++) {   //The second for statement is labeled "loop2"
      if (i === 1 &amp;&amp; j === 1) {
         break loop1;
      }
      console.log('i = ' + i + ', j = ' + j);
   }
}

// Output is:
//   "i = 0, j = 0"
//   "i = 0, j = 1"
//   "i = 0, j = 2"
//   "i = 1, j = 0"
// Notice the difference with the previous continue example</pre>

<h3 id="Using_a_labeled_break_statement">Using a labeled break statement</h3>

<p>Given an array of items and an array of tests, this example determines whether all items pass all tests.</p>

<pre class="brush: js notranslate">var allPass = true;
var i, j;

top:
for (i = 0; i &lt; items.length; i++) {
  for (j = 0; j &lt; tests.length; j++) {
    if (!tests[j].pass(items[i])) {
      allPass = false;
      break top;
    }
  }
}</pre>

<h3 id="Using_a_labeled_block_with_break">Using a labeled block with break</h3>

<p>You can use labels within simple blocks, but only <code>break</code> statements can make use of non-loop labels.</p>

<pre class="brush: js notranslate">foo: {
  console.log('face');
  break foo;
  console.log('this will not be executed');
}
console.log('swap');

// this will log:

// "face"
// "swap" </pre>

<h3 id="Labeled_function_declarations">Labeled function declarations</h3>

<p>Starting with ECMAScript 2015, labeled function declarations are now standardized for non-strict code in the <a href="http://www.ecma-international.org/ecma-262/6.0/#sec-labelled-function-declarations">web compatibility annex of the specification</a>.</p>

<pre class="brush: js notranslate">L: function F() {}</pre>

<p>In <a href="/en-US/docs/Web/JavaScript/Reference/Strict_mode">strict mode</a> code, however, this will throw a {{jsxref("SyntaxError")}}:</p>

<pre class="brush: js notranslate">'use strict';
L: function F() {}
// SyntaxError: functions cannot be labelled</pre>

<p><a href="/en-US/docs/Web/JavaScript/Reference/Statements/function*">Generator functions</a> can neither be labeled in strict code, nor in non-strict code:</p>

<pre class="brush: js notranslate">L: function* F() {}
// SyntaxError: generator functions cannot be labelled
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('ESDraft', '#sec-labelled-statements', 'Labelled statement')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("javascript.statements.label")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{jsxref("Statements/break", "break")}}</li>
 <li>{{jsxref("Statements/continue", "continue")}}</li>
</ul>
